<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    v-if="visible"
    :visible.sync="visible"
    :title="title"
    :close-on-click-modal="false"
    width="70%"
    @close="cancel"
    :maxable="true"
    :resizable="true"
  >
    <el-form
      ref="form"
      :model="form"
      :rules="rules"
      class="el-form-box"
      label-width="120px"
    >
      <headerTitle title="订单信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item label="订单类型" prop="sourceType">
            <el-select
              v-model="form.sourceType"
              placeholder="请选择"
              style="width: 100%"
              @change="sourceTypeChange"
              :disabled="isFlag"
              clearable
            >
              <el-option
                v-for="item in requirementSourceType"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="来源类型" prop="relationType">
            <el-select
              v-model="form.relationType"
              filterable
              clearable
              style="width: 100%"
              @change="handleChangeRelationType"
            >
              <el-option :value="1" label="采购需求单"></el-option>
              <el-option :value="2" label="采购计划单"></el-option>
              <el-option :value="3" label="采购核价单"></el-option>
              <el-option :value="4" label="采购合同"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item
            prop="outsourceScene"
            label="委外场景"
            v-if="
              orderSourceType.includes(form.sourceType) && form.outsourceScene
            "
          >
            <el-select
              v-model="form.outsourceScene"
              disabled
              style="width: 100%"
            >
              <el-option
                :value="item.value"
                :label="item.label"
                v-for="item in outsourceSceneList"
                :key="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item
            v-if="form.relationType == 1"
            label="采购需求单"
            prop="relationName"
          >
            <el-input
              @click.native="handPurchaseNeed"
              v-model="form.relationName"
              placeholder="请选择"
            ></el-input>
          </el-form-item>
          <el-form-item
            v-if="form.relationType == 2"
            label="采购计划单"
            prop="relationName"
          >
            <el-input
              @click.native="handPurchasePlan"
              v-model="form.relationName"
              placeholder="请选择"
            ></el-input>
          </el-form-item>
          <el-form-item
            v-if="form.relationType == 3"
            label="采购核价单"
            prop="relationName"
          >
            <el-input
              @click.native="handInquiry"
              v-model="form.relationName"
              placeholder="请选择"
            ></el-input>
          </el-form-item>
          <el-form-item
            v-if="form.relationType == 4"
            label="选择合同"
            prop="contractName"
          >
            <el-input
              clearable
              v-model="form.contractName"
              @click.native="handleContractBtn"
              @clear="clearContrcat"
              placeholder="请输入"
            />
          </el-form-item>

          <el-form-item label="需求部门" prop="requireDeptId">
            <ele-tree-select
              clearable
              :data="groupTreeData"
              v-model="form.requireDeptId"
              valueKey="id"
              labelKey="name"
              placeholder="请选择"
              @change="change_principalDep"
              default-expand-all
            />
          </el-form-item>

          <el-form-item prop="orderFiles" label="附件">
            <fileMain v-model="form.orderFiles"></fileMain>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="项目名称" prop="projectName">
            <el-input
              clearable
              v-model="form.projectName"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="结算方式" prop="settlementMode">
            <DictSelection
              dictName="结算方式"
              clearable
              @itemChange="settlementModeChange"
              v-model="form.settlementMode"
            >
            </DictSelection>
          </el-form-item>

          <el-form-item label="需求人" prop="requireUserId">
            <personSelect
              ref="directorRef"
              v-model="form.requireUserId"
              @selfChange="salesmanChange"
              :init="false"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <headerTitle title="基本信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item label="采购方名称" prop="partaName">
            <el-select
              style="width: 100%"
              v-model="form.partaName"
              placeholder="请选择"
              @change="getEnterprise()"
            >
              <el-option
                v-for="item in enterprisePage"
                :key="item.id"
                :label="item.name"
                :value="item.name"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item
            label="采购方统一社会信用代码"
            class="form_item_label"
            prop="partaUnifiedSocialCreditCode"
          >
            <el-input
              clearable
              v-model="form.partaUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="采购方联系人" prop="partaLinkName">
            <el-input
              clearable
              v-model="form.partaLinkName"
              @click.native="handHead"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="采购方电话" prop="partaTel">
            <el-input
              clearable
              :maxlength="20"
              v-model="form.partaTel"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="采购方传真" prop="partaFax">
            <el-input clearable v-model="form.partaFax" placeholder="请输入" />
          </el-form-item>
          <el-form-item label="	采购方Email" prop="partaEmail">
            <el-input
              clearable
              v-model="form.partaEmail"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="采购方地址" prop="partaAddress">
            <el-input
              clearable
              v-model="form.partaAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="供应商名称" prop="partbName">
            <el-row>
              <el-col :span="form.partbName ? 19 : 24">
                <el-input
                  clearable
                  v-model="form.partbName"
                  @click.native="handParent"
                  :disabled="!!form.contractId"
                  placeholder="请选择"
                >
                </el-input>
              </el-col>
              <el-col :span="5">
                <el-button
                  v-if="form.partbName"
                  style="color: #fff; background: #1890ff"
                  @click.native="handleGoodsList"
                  >供货列表
                </el-button>
              </el-col>
            </el-row>
          </el-form-item>
          <el-form-item
            label="供应商统一社会信用代码"
            prop="partbUnifiedSocialCreditCode"
            class="form_item_label"
          >
            <el-input
              clearable
              v-model="form.partbUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="供应商联系人" prop="partbLinkName">
            <el-select
              style="width: 100%"
              v-model="form.partbLinkName"
              placeholder="请选择"
              @change="onchangeLink"
            >
              <el-option
                v-for="item in linkNameOptions"
                :key="item.id"
                :label="item.linkName"
                :value="item.id"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item prop="partbTel" label="供应商联系电话">
            <el-input clearable v-model="form.partbTel" placeholder="请输入" />
          </el-form-item>
          <el-form-item prop="partbFax" label="供应商传真">
            <el-input clearable v-model="form.partbFax" placeholder="请输入" />
          </el-form-item>

          <el-form-item label="供应商Email" prop="partbEmail">
            <el-input
              clearable
              v-model="form.partbEmail"
              placeholder="请输入"
            />
          </el-form-item>

          <el-form-item label="供应商地址" prop="partbAddress">
            <el-input
              clearable
              v-model="form.partbAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>

      <!-- <headerTitle title="产品清单" style="margin-top: 30px"></headerTitle> -->
      <el-tabs v-model="activeName" style="margin-top: 15px" type="border-card">
        <el-tab-pane label="物品清单" name="1">
          <inventoryTable
            ref="inventoryTable"
            @orderDiscountAmount="orderDiscountAmount"
            :pricingWay="form.pricingWay"
            :supplierMark="form.supplierMark"
            :is-show-supplier-mark="true"
            :isContractId="
              !!form.contractId && !OutValidate.includes(form.sourceType)
            "
          >
          </inventoryTable>
        </el-tab-pane>
        <el-tab-pane
          label="带料清单"
          name="2"
          v-if="orderSourceType.includes(form.sourceType)"
        >
          <inventoryTable
            ref="rawDetailListRef"
            :detailType="1"
            :pricingWay="form.pricingWay"
            :supplierMark="form.supplierMark"
            :is-show-supplier-mark="true"
            :isContractId="
              !!form.contractId && !OutValidate.includes(form.sourceType)
            "
          ></inventoryTable>
        </el-tab-pane>
        <el-tab-pane
          label="产出清单"
          name="3"
          v-if="orderSourceType.includes(form.sourceType)"
        >
          <inventoryTable
            ref="outputDetailListRef"
            :detailType="2"
            :pricingWay="form.pricingWay"
            :supplierMark="form.supplierMark"
            :is-show-supplier-mark="true"
            :isContractId="
              !!form.contractId && !OutValidate.includes(form.sourceType)
            "
          ></inventoryTable>
        </el-tab-pane>
      </el-tabs>

      <el-row style="margin-top: 20px">
        <el-col :span="12">
          <el-form-item label="总金额" prop="totalAmount">
            {{ allcountAmount || 0 }}元
          </el-form-item>
          <el-form-item label="备注" prop="remark">
            <el-input
              clearable
              type="textarea"
              v-model="form.remark"
              placeholder="请输入"
            />
          </el-form-item>
          <!-- <el-form-item
            label="收货地址"
            prop="receiveAddress"

          >
            <el-input
              clearable
              type="textarea"
              v-model="form.receiveAddress"
              placeholder="请输入"
            />
          </el-form-item> -->
        </el-col>
        <el-col :span="12">
          <el-form-item label="优惠后总金额" prop="payAmount">
            <el-input
              clearable
              v-model="form.payAmount"
              :disabled="
                (!!form.contractId && !OutValidate.includes(form.sourceType)) ||
                !allcountAmount
              "
              type="number"
              @blur="discountInput"
              placeholder="请输入"
            >
              <template slot="append">元</template>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <div slot="footer" class="footer">
      <el-button type="primary" @click="save" v-click-once>保存</el-button>
      <el-button type="primary" @click="save('sub')" v-click-once
        >提交</el-button
      >

      <el-button @click="cancel">返回</el-button>
    </div>

    <parentList
      ref="parentRef"
      @changeParent="changeParent"
      :classType="2"
    ></parentList>
    <head-list ref="headRef" @changeParent="changePersonel"></head-list>
    <contractListDialog
      :hasGeneratedOrder="
        this.OutValidate.includes(this.form.sourceType) ? 3 : 0
      "
      ref="selectContractRef"
      @changeParent="changeContract"
      :type="2"
      :sourceType="form.sourceType"
    ></contractListDialog>
    <inquiryManageList
      ref="inquiryManageRef"
      @changeInquiryManageList="changeInquiryManageList"
    ></inquiryManageList>
    <process-submit-dialog
      :isNotNeedProcess="false"
      :processSubmitDialogFlag.sync="processSubmitDialogFlag"
      v-if="processSubmitDialogFlag"
      ref="processSubmitDialogRef"
      @reload="reload"
    ></process-submit-dialog>
    <purchaseNeedList
      ref="purchaseNeedList"
      @changeParent="changePurchaseNeedList"
    ></purchaseNeedList>
    <inquiryList
      ref="inquiryListRef"
      @changeParent="changeInquiryList"
    ></inquiryList>
    <supplier-goods-list-dialog
      @changeParent="changeValue"
      :supplier-goods-list-dialog-flag.sync="supplierGoodsListDialogFlag"
      v-if="supplierGoodsListDialogFlag"
      ref="supplierGoodsListDialogRef"
    ></supplier-goods-list-dialog>
    <planTableList
      ref="planTableListRef"
      @success="putTableValue"
      @contractSuccess="contractSuccess"
    ></planTableList>
  </ele-modal>
</template>

<script>
  import { emailReg, telReg } from 'ele-admin';
  import inventoryTable from './inventoryTable.vue';
  import planTableList from './planTableList.vue';
  import fileUpload from '@/components/upload/fileUpload';
  import dictMixins from '@/mixins/dictMixins';
  import deptSelect from '@/components/CommomSelect/dept-select.vue';
  import personSelect from '@/components/CommomSelect/person-select.vue';
  import parentList from '@/views/purchasingManage/supplierManage/components/parentList.vue';
  import {
    enterprisePage,
    getDetail,
    updateContractStatus
  } from '@/api/contractManage/contractBook';
  import supplierGoodsListDialog from '@/views/purchasingManage/purchaseOrder/components/supplierGoodsListDialog.vue';
  import {
    addInformation,
    getProductsBySource,
    getPurchaseinquiryAPI,
    getpurchaseorderDetail,
    getPurchasePlanByContractIdAPI,
    UpdateInformation
  } from '@/api/purchasingManage/purchaseOrder';
  import { getplanDetail } from '@/api/purchasingManage/purchasePlanManage';
  import { getpurchaseinquiry } from '@/api/purchasingManage/inquiryManage';
  import { getcontactlink } from '@/api/saleManage/businessFollow';
  import headList from '@/BIZComponents/user-select/user-select.vue';
  import contractListDialog from '@/views/saleManage/saleOrder/components/contractListDialog.vue';
  import { listOrganizations } from '@/api/system/organization';
  import { copyObj } from '@/utils/util';
  import inquiryManageList from '@/views/purchasingManage/inquiryManage/components/inquiryManage-list.vue';
  // import fileMain from '@/components/addDoc/index.vue';
  import processSubmitDialog from '@/BIZComponents/processSubmitDialog/processSubmitDialog.vue';
  import purchaseNeedList from '@/views/purchasingManage/purchasePlanManage/components/purchaseNeed-list.vue';
  import inquiryList from './inquiryList.vue';
  import {
    contactDetail,
    updateRelationStatus
  } from '@/api/saleManage/contact';
  import {
    requirementSourceType,
    acceptUnpackoptions,
    orderSourceType,
    outsourceSceneList
  } from '@/enum/dict.js';

  export default {
    mixins: [dictMixins],
    props: {
      isRequired: {
        type: Boolean,
        default: true
      }
    },
    components: {
      inquiryList,
      purchaseNeedList,
      processSubmitDialog,
      // fileMain,
      inquiryManageList,
      fileUpload,
      headList,
      contractListDialog,
      inventoryTable,
      deptSelect,
      parentList,
      personSelect,
      supplierGoodsListDialog,
      planTableList
    },
    data() {
      let formDef = {
        id: '',
        contractId: '',
        relationType: '',
        relationName: '',
        orderFiles: [],
        contractName: '',
        deliveryDate: '',
        payAmount: '',
        projectName: '',
        projectId: '',
        receiveAddress: '',
        sourceType: '',
        sourceTypeName: '',
        pricingWay: 1,
        remark: '',
        saleType: '',
        saleTypeName: '',
        totalAmount: '',
        settlementMode: '4',
        settlementModeName: '分期付款',
        partaUnifiedSocialCreditCode: '',
        partbUnifiedSocialCreditCode: '',
        partaAddress: '',
        partaEmail: '',
        partaFax: '',
        partaId: '',
        partaLinkId: '',
        partaLinkName: '',
        partaName: '',
        partaTel: '',
        partbAddress: '',
        partbEmail: '',
        partbFax: '',
        partbId: '',
        partbLinkId: '',
        partbLinkName: '',
        partbName: '',
        partbTel: '',
        purchasePlanId: '',
        purchasePlanNo: '',
        purchasePlanName: '',
        isFirstProcess: 0
      };

      return {
        orderSourceType,
        outsourceSceneList,
        requirementSourceType,
        processList: [
          {
            label: '是',
            value: 1
          },
          {
            label: '否',
            value: 0
          }
        ],
        isFlag: false, //订单类型是否不可修改
        clearing: false, //是否清除合同
        payWayOptions: [],
        delDetailIds: [],
        linkNameOptions: [],
        acceptUnpackoptions,
        visible: false,
        fullscreen: false,
        processSubmitDialogFlag: false,
        supplierGoodsListDialogFlag: false,
        title: '',
        row: {},
        activeName: '1',
        pricingWayList: [
          { id: 1, name: '按数量计价' },
          { id: 2, name: '按重量计价' }
        ],
        formDef,
        form: copyObj(formDef),
        enterprisePage: [],
        tableBankData: [],
        tableLinkData: [],
        // 组织机构树形结构数据
        groupTreeData: [],
        groupData: [],
        OutValidate: ['3', '4'],

        // 提交状态
        loading: false,
        // 是否是修改
        isUpdate: false,
        businessId: '',
        winnerSuppleIds: '',
      };
    },
    computed: {
      allcountAmount() {
        return this.$store.state.order.allcountAmount;
      },
      rules() {
        let isRequired=this.isRequired
        // console.log(this.isRequired);
        
        return {
          deliveryDate: [
            { required: true, message: '请选择交货日期', trigger: 'change' }
          ],
          purchasePlanName: [
            {
              required: this.OutValidate.includes(this.form.sourceType),
              message: '请选择采购计划单',
              trigger: ['change', 'blur']
            }
          ],
          relationName: [
            {
              required: true,
              message: '请选择',
              trigger: ['change', 'blur']
            }
          ],
          contractName: [
            {
              required: true,
              message: '请选择合同',
              trigger: ['change', 'blur']
            }
          ],
          // purchaseType: [
          //   {required: true, message: '请选择采购订单类型', trigger: 'change'}
          // ],
          settlementMode: [
            { required: true, message: '请选择结算方式', trigger: 'change' }
          ],
          partaName: [
            {
              required: true,
              message: '请选择供应商名称',
              trigger: 'change'
            }
          ],
          partaLinkName: [
            { required: isRequired, message: '请选择供应商联系人', trigger: 'change' }
          ],
          acceptUnpack: [
            { required: true, message: '请选择是否接受', trigger: 'change' }
          ],
          sourceType: [
            { required: true, message: '请选择订单类型', trigger: 'change' }
          ],
          payAmount: [{ required: true, message: '请输入', trigger: 'blur' }],
          partbAddress: [
            { required: true, message: '请输入', trigger: 'blur' }
          ],
          partaTel: [
            {
              required: isRequired,
              pattern: telReg,
              message: '请输入供应商联系电话',
              trigger: 'blur'
            }
          ],

          partbName: [
            { required: true, message: '请输入供采购方名称', trigger: 'change' }
          ],
          partbLinkName: [
            {
              required: isRequired,
              message: '请输入供采购方联系人',
              trigger: 'change'
            }
          ],
          partbTel: [
            {
              required: isRequired,
              pattern: telReg,
              message: '请输入供采购方联系电话',
              trigger: 'blur'
            }
          ],
          partaEmail: [
            { pattern: emailReg, message: '邮箱格式不正确', trigger: 'blur' }
          ]
        };
      }
    },
    created() {
      console.log(this);
      
      this.getGroupAll();
      this.getEnterprisePage();
      this.changePersonel();
    },
    methods: {
      // 选择负责人部门
      change_principalDep(id) {
        const info = this.groupData.find((e) => e.id == id);
        this.form.requireDeptName = info.name;
        // this.form.requireUserId = '';
        // this.form.requireUserName = '';
        this.$set(this.form, 'requireUserId', '');
        this.$set(this.form, 'requireUserName', '');
        // 根据部门获取人员

        this.getrequireUser(id);
      },

      //选择采购需求
      handPurchaseNeed() {
        this.$refs.purchaseNeedList.open(
          this.form.relationCode,
          this.form.sourceType
        );
      },
      //选择采购需求回调
      async changePurchaseNeedList(data) {
        this.form.relationId = data.id;
        this.form.relationCode = data.requirementCode;
        this.form.relationName = data.requirementName;

        this.$set(this.form, 'relationName', data.requirementName);
        this.$set(this.form, 'relationId', data.id);
        this.$set(this.form, 'relationCode', data.requirementCode);
        this.$set(this.form, 'requireDeptId', data.requireDeptId);
        this.$set(this.form, 'requireDeptName', data.requireDeptName);
        this.$set(this.form, 'requireUserId', data.requireUserId);
        this.$set(this.form, 'requireUserName', data.requireUserName);
        this.getrequireUser(data.requireDeptId);

        let info = await getProductsBySource({
          relationId: this.form.relationId,
          relationType: this.form.relationType
        });
        let form = {
          contractVO: {
            ...this.form
          },
          productList: info.productList || []
        };

        this.$refs.inventoryTable &&
          this.$refs.inventoryTable.putTableValue(form.productList);
      },

      //选择采购计划
      handPurchasePlan() {
        this.$refs.inquiryManageRef.open(
          this.form.planCode,
          this.form.sourceType
        );
      },
      //选择采购计划回调
      async changeInquiryManageList(data) {
        this.form.purchasePlanId = data.id;
        this.form.purchasePlanNo = data.planCode;
        this.form.purchasePlanName = data.planName;

        this.form.relationId = data.id;
        this.form.relationCode = data.planCode;
        this.form.relationName = data.planName;
        this.form.requireDeptId = data.requireDeptId;
        this.form.requireDeptName = data.requireDeptName;
        this.form.requireUserId = data.requireUserId;
        this.form.requireUserName = data.requireUserName;
        this.$set(this.form, 'requireDeptId', data.requireDeptId);
        this.$set(this.form, 'requireDeptName', data.requireDeptName);
        this.$set(this.form, 'requireUserId', data.requireUserId);
        this.$set(this.form, 'requireUserName', data.requireUserName);
        this.getrequireUser(data.requireDeptId);
        // let cusInfo = {}
        this.$set(this.form, 'purchasePlanName', data.planName);
        this.$set(this.form, 'purchasePlanId', data.id);
        this.$set(this.form, 'purchasePlanNo', data.planCode);

        this.$set(this.form, 'relationName', data.planName);
        this.$set(this.form, 'relationId', data.id);
        this.$set(this.form, 'relationCode', data.planCode);
        const res = await getplanDetail(data.id);
        this.$set(this.form, 'isFirstProcess', res.isFirstProcess);

        let info = await getProductsBySource({
          relationId: this.form.relationId,
          relationType: this.form.relationType
        });
        info['rawDetailList'] = info.rawList;
        info['outputDetailList'] = info.outputList;
        if (info.productList.length > 1) {
          this.$refs.planTableListRef.open(info);
        } else {
          this.$nextTick(() => {
            this.putTableValue(info);
          });
        }
        // let form = {
        //   contractVO: {
        //     ...this.form
        //   },
        //   productList: info.productList || []
        // }
        // const codeList = form.productList.map((item) => item.productCode);
        // let inventoryTotalList = await getInventoryTotalAPI(codeList);
        // form.productList.forEach((item) => {
        //   let find =
        //     inventoryTotalList.find((key) => key.code == item.productCode) || {};
        //   item.availableCountBase = find.availableCountBase;
        // });
        // this.$refs.inventoryTable &&
        // this.$refs.inventoryTable.putTableValue(form.productList);
      },
      //选择核价单
      handInquiry(e) {
        this.$refs.inquiryListRef.open(this.form.sourceType);
      },
      //选择采购核价回调
      async changeInquiryList(data) {
        console.log(data, '=======');
        this.form.relationId = data.id;
        this.form.relationCode = data.inquiryCode;
        this.form.relationName = data.inquiryName;
        this.winnerSuppleIds = data.winnerSuppleIds;
        this.$set(this.form, 'relationName', data.inquiryName);
        this.$set(this.form, 'relationId', data.id);
        this.$set(this.form, 'relationCode', data.inquiryCode);
        const res = await getpurchaseinquiry(data.id);
        this.$set(this.form, 'isFirstProcess', res.isFirstProcess);

        let info = await getProductsBySource({
          relationId: this.form.relationId,
          relationType: this.form.relationType,
          supplierId: this.winnerSuppleIds
        });
        info['rawDetailList'] = info.rawList;
        info['outputDetailList'] = info.outputList;

        info.productList.forEach((item) => {
          item['discountSinglePrice'] = item.singlePrice;
          item['discountTotalPrice'] = item.totalPrice;
        });
        if (info.productList.length > 1) {
          this.$refs.planTableListRef.open(info);
        } else {
          this.$nextTick(() => {
            this.putTableValue(info);
          });
        }

        this.form = {
          ...this.form,
          partbId: info.partbId,
          partbName: info.partbName,
          partbAddress: info.partaAddress,
          partbLinkId: info.partaAddress,
          partbLinkName: info.partbLinkName,
          partbEmail: info.partbEmail,
          partbTel: info.partbTel
        };
        await this.getLinkInfo(info.partbId);
        this.$nextTick(() => {
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          this.form = Object.assign({}, this.form, {
            partbLinkId: firstLink.id || this.linkNameOptions[0]?.id,
            partbLinkName:
              firstLink.linkName || this.linkNameOptions[0]?.linkName,
            partbTel:
              firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          });
          this.setProductInfo();
        });
        await this.changeParent({ id: info.partbId });
      },

      async putTableValue({ productList, rawDetailList, outputDetailList }) {
        let totalPrice = 0;
        productList.forEach((item) => {
          totalPrice += item.totalPrice;
        });
        this.$store.commit('order/setAllcountAmount', totalPrice);
        this.$set(this.form, 'totalPrice', totalPrice);
        if (this.form.relationType == 3) {
          this.$set(this.form, 'payAmount', totalPrice);
        }

        this.$refs.inventoryTable &&
          this.$refs.inventoryTable.putTableValue(productList);
        this.$refs.rawDetailListRef &&
          this.$refs.rawDetailListRef.putTableValue(rawDetailList); //原料
        this.$refs.outputDetailListRef &&
          this.$refs.outputDetailListRef.putTableValue(outputDetailList);
      },

      getrequireUser(groupId) {
        if (groupId) {
          this.$refs.directorRef.getList({ groupId });
        }
      },
      salesmanChange(val, info) {
        this.$set(this.form, 'requireUserId', val);
        this.$set(this.form, 'requireUserName', info.name);
        // this.form.requireUserName = info.name;
      },
      // 获取公司数据
      getGroupAll() {
        listOrganizations().then((list) => {
          this.groupData = list;
          this.groupTreeData = this.$util.toTreeData({
            data: list,
            idField: 'id',
            parentIdField: 'parentId'
          });
        });
      },
      discountInput() {
        this.$refs.inventoryTable.discountInputByOrder(this.form.payAmount);
      },
      //产品清单修改单价或者数量重置优惠金额
      orderDiscountAmount(val = 0) {
        this.form.payAmount = val;
        //this.form.payAmount = undefined
      },

      //选择合同获取合同的详情
      async getDetailData(id) {
        this.loading = true;
        const data = await getDetail(id);
        let info = await getProductsBySource({
          relationId: this.form.relationId,
          relationType: this.form.relationType
        });

        this.loading = false;
        if (data) {
          // if (data.contractVO.sourceType == 3 && data.contractVO.sourceId) {
          //   //获取需求部门
          //   const res = await getplanDetail(data.contractVO.sourceId);
          //   this.$nextTick(() => {
          //     this.form.requireDeptId = res.requireDeptId;
          //     this.form.requireDeptName = res.requireDeptName;
          //     this.form.requireUserId = res.requireUserId;
          //     this.form.requireUserName = res.requireUserName;
          //   });
          // }
          this.$set(this.form, 'requireDeptId', data.contractVO?.requireDeptId);
          this.$set(
            this.form,
            'requireDeptName',
            data.contractVO?.requireDeptName
          );
          this.$set(this.form, 'requireUserId', data.contractVO?.requireUserId);
          this.$set(
            this.form,
            'requireUserName',
            data.contractVO?.requireUserName
          );
          this.getrequireUser(data.contractVO?.requireDeptId);
          this.$nextTick(() => {
            let { contractVO } = data;
            // this.form=contractVOform.receiveAddress
            let {
              partaAddress,
              partaEmail,
              partaFax,
              partaId,
              partaLinkId,
              partaLinkName,
              partaName,
              partaTel,
              partbAddress,
              partbEmail,
              partbFax,
              partbId,
              partbLinkId,
              partbLinkName,
              partbName,
              partbTel,
              totalPrice,
              discountTotalPrice,
              partaUnifiedSocialCreditCode,
              partbUnifiedSocialCreditCode,
              settlementMode,
              settlementModeName,
              pricingWay,
              isFirstProcess,
              requireSourceType,
              requireSourceTypeName
            } = contractVO;
            this.form = Object.assign({}, this.form, {
              partaAddress,
              partaEmail,
              partaFax,
              partaId,
              partaLinkId,
              partaLinkName,
              partaName,
              partaTel,
              partbAddress,
              partbEmail,
              partbFax,
              partbId,
              partbLinkId,
              partbLinkName,
              partbName,
              partbTel,
              totalPrice,
              settlementMode,
              settlementModeName,
              discountTotalPrice,
              partaUnifiedSocialCreditCode,
              partbUnifiedSocialCreditCode,
              pricingWay,
              totalAmount: totalPrice,
              payAmount: discountTotalPrice,
              receiveAddress: partaAddress,
              isFirstProcess,
              sourceType: requireSourceType || '1',
              sourceTypeName: requireSourceTypeName
            });
            this.getLinkInfo(partaId);

            if (info.productList.length > 1) {
              this.$refs.planTableListRef.contractOpen(
                info.productList,
                contractVO.contractStartDate
              );
            } else {
              this.contractSuccess({
                productList: info.productList,
                contractStartDate: contractVO.contractStartDate
              });
            }

            this.$refs.rawDetailListRef &&
              this.$refs.rawDetailListRef.putTableValue(contractVO.rawList); //原料
            this.$refs.outputDetailListRef &&
              this.$refs.outputDetailListRef.putTableValue(
                contractVO.outputList
              );
            this.$store.commit('order/setAllcountAmount', totalPrice);
          });
        }
      },
      contractSuccess({ productList, contractStartDate }) {
        this.$nextTick(() => {
          this.$refs.inventoryTable &&
            this.$refs.inventoryTable.putTableValue(
              productList,
              contractStartDate
            );
        });
      },
      //获取订单详情
      async getpurchaseorderDetail(id) {
        this.businessId = id;
        this.loading = true;
        const data = await getpurchaseorderDetail(id);
        this.loading = false;
        if (data) {
          this.$nextTick(() => {
            this.form = data;
            this.$store.commit('order/setAllcountAmount', data.totalAmount);
            this.$refs.inventoryTable &&
              this.$refs.inventoryTable.putTableValue(data.productList);
            this.$refs.rawDetailListRef &&
              this.$refs.rawDetailListRef.putTableValue(data.rawList); //原料
            this.$refs.outputDetailListRef &&
              this.$refs.outputDetailListRef.putTableValue(data.outputList); //产成品
            this.getLinkInfo(data.partaId);
            this.getrequireUser(this.form.requireDeptId);
            this.$store.commit('order/setContractId', data.contractId);
          });
        }
      },

      //更新联系人数据
      async getLinkInfo(contactId) {
        const data = await getcontactlink({ contactId });
        if (data && data?.length) {
          this.linkNameOptions = data;
        }
      },

      sourceTypeChange() {
        this.valueChange();
      },
      handleChangeRelationType(val) {
        this.valueChange();
      },
      valueChange() {
        this.form.purchasePlanId = '';
        this.form.purchasePlanNo = '';
        this.form.purchasePlanName = '';

        this.form.relationId = '';
        this.form.relationCode = '';
        this.form.relationName = '';
        this.$nextTick(() => {
          this.$refs.inventoryTable &&
            this.$refs.inventoryTable.putTableValue([]);
        });
      },
      //选择下拉框
      onchangeLink(selectedOptions) {
        const option = this.linkNameOptions.find(
          (opt) => opt.id === selectedOptions
        );
        this.form = Object.assign({}, this.form, {
          partbEmail: option?.email,
          partbLinkName: option?.linkName || '',
          partbTel: option?.mobilePhone || option?.phone || '',
          partbLinkId: option?.id
        });
      },

      handHead() {
        let item = {
          id: this.form.partaLinkId
        };
        this.$refs.headRef.open(item);
      },

      //选择供采购方人回调
      changePersonel(obj) {
        if (!obj) {
          obj = this.$store.getters.user.info;
          obj.id = obj.userId;
        }
        this.$set(this.form, 'partaLinkId', obj.id);
        this.$set(this.form, 'partaLinkName', obj.name);
        this.$set(this.form, 'partaTel', obj.phone);
        this.$set(this.form, 'partaEmail', obj.email);
      },
      //选择供应商回调
      async changeParent(obj) {
        if (!obj.id) {
          return;
        }
        const { base, other } = await contactDetail(obj.id);

        this.form = Object.assign({}, this.form, {
          partbId: base.id,
          partbName: base.name,
          partbAddress: other.addressName
            ? other.addressName + other.address
            : base.addressName + other.address,
          partbLinkId: '',
          partbLinkName: '',
          partbEmail: '',
          partbTel: '',
          supplierMark: base.serialNo,
          partbUnifiedSocialCreditCode: base.unifiedSocialCreditCode
        });
        await this.getLinkInfo(obj.id);

        //  this.form.productList=productList

        this.$nextTick(() => {
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          this.form = Object.assign({}, this.form, {
            partbLinkId: firstLink.id || this.linkNameOptions[0]?.id,
            partbLinkName:
              firstLink.linkName || this.linkNameOptions[0]?.linkName,
            partbTel:
              firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          });
          this.setProductInfo();
        });
      },
      setProductInfo() {
        this.$refs.inventoryTable.setCustomerMark(this.form.supplierMark);
      },
      //选择合同回调
      async changeContract(obj) {
        this.form = Object.assign({}, this.form, {
          contractId: obj.id,
          contractName: obj.contractName,
          contractNo: obj.contractNo,
          relationId: obj.id,
          relationName: obj.contractName,
          relationCode: obj.contractNo
        });

        await this.getPlanInfo(this.form.contractId);
        await this.getDetailData(obj.id);
        // //采购询价表
        // if(obj.sourceType==2){
        //   obj.sourceId && this.getPurchaseinquiry(obj.sourceId);
        // }
        // //采购计划
        // if(obj.sourceType==3){
        //   obj.sourceId && this.getPlanInfo(this.form.contractId);
        // }

        this.$store.commit('order/setContractId', obj.id);
        //获取合同采购计划
      },
      async getPlanInfo(id) {
        let res = await getPurchasePlanByContractIdAPI(id);
        if (!res.data?.id) return;
        this.form = Object.assign({}, this.form, {
          purchasePlanId: res.data?.id,
          purchasePlanName: res.data?.planName,
          purchasePlanNo: res.data?.planCode,
          sourceType: res.data?.sourceType,
          sourceTypeName: res.data?.sourceTypeName
        });
      },

      //选择合同弹框
      handleContractBtn() {
        if (this.clearing) return;
        let item = {
          id: this.form.contractId
        };
        this.$refs.selectContractRef.open(item, this.form.sourceType);
      },
      //清除合同
      clearContrcat() {
        this.clearing = true;
        this.isFlag = false;
        let {
          sourceType,
          sourceTypeName,
          requireDeptId,
          requireDeptName,
          requireUserId,
          requireUserName,
          settlementMode,
          settlementModeName,

          id,
          projectName,
          saleType,
          saleTypeName,
          deliveryDate,
          orderFiles,
          remark
        } = this.form;
        this.form = Object.assign({}, copyObj(this.formDef), {
          id,
          projectName,
          saleType,
          saleTypeName,
          deliveryDate,
          orderFiles,
          remark,
          sourceType,
          sourceTypeName,
          requireDeptId,
          requireDeptName,
          requireUserId,
          requireUserName,
          settlementMode,
          settlementModeName
        });

        this.$store.commit('order/setContractId', '');
        this.$store.commit('order/setAllcountAmount', 0);
        this.$refs.inventoryTable.putTableValue([]);
        this.$refs.rawDetailListRef &&
          this.$refs.rawDetailListRef.putTableValue([]);
        this.$refs.outputDetailListRef &&
          this.$refs.outputDetailListRef.putTableValue([]);

        setTimeout(() => {
          this.clearing = false;
        }, 500);
      },

      handParent() {
        if (this.form.contractId) {
          return this.$message.error('选择了合同不能更改供应商名称');
        }
        let item = {
          id: this.form.contactId
        };
        this.$refs.parentRef.open(item);
      },
      //通过合同获取订单类型
      async getPurchaseinquiry(sourceId) {
        let data = await getPurchaseinquiryAPI(sourceId);
        this.isFlag = !!data.sourceType;
        this.form = Object.assign({}, this.form, {
          sourceType: data.sourceType,
          sourceTypeName: data.sourceTypeName
        });
      },
      //打开新增编辑弹框
      async open(type, row, contactCategoryId) {
        this.title = type === 'add' ? '新增' : '修改';
        this.activeName = '1';

        this.row = row;
        this.visible = true;
        if (this.enterprisePage.length == 0) {
          await this.getEnterprisePage();
        }
        if (type == 'add') {
          this.isUpdate = false;
          if (this.enterprisePage.length > 0) {
            this.form.partaName = this.enterprisePage[0]?.name;
            this.form.partaUnifiedSocialCreditCode =
              this.enterprisePage[0]?.unifiedSocialCreditCode;
            this.form.partaFax = this.enterprisePage[0]?.fax;
            this.form.partaAddress = this.enterprisePage[0]?.address;
          }
        } else {
          this.isUpdate = true;
          await this.getpurchaseorderDetail(row.id);
        }
      },
      getEnterprisePage() {
        enterprisePage({
          pageNum: 1,
          size: 100
        }).then((res) => {
          this.enterprisePage = [];
          this.enterprisePage.push(...res.list);
        });
      },
      getEnterprise() {
        let data = this.enterprisePage.find(
          (item) => item.name == this.form.quoteName
        );
        this.form.partaName = data.name;
        this.form.partaUnifiedSocialCreditCode = data.unifiedSocialCreditCode;
        this.form.partaFax = data.fax;
        this.form.partaAddress = data.address;
      },
      //从合同页面新增订单
      contractOpen(row) {
        this.title = '新增';
        this.visible = true;
        this.isUpdate = false;
        this.form.relationType = 4;
        this.changeContract(row);
      },
      handleGoodsList() {
        console.log(11111);
        this.supplierGoodsListDialogFlag = true;
        this.$nextTick(() => {
          this.$refs.supplierGoodsListDialogRef.open(this.form.partbId);
        });
      },
      changeValue(val = []) {
        this.$refs.inventoryTable &&
          this.$refs.inventoryTable.getGoodsListData(val);
      },
      settlementModeChange(info) {
        this.form.settlementModeName = info.dictValue;
      },
      ifChiefChange(value, idx) {
        if (value === 1) {
          this.tableLinkData.forEach((e) => (e.ifChief = 0));
          this.tableLinkData[idx].ifChief = 1;
        }
      },

      getValidate() {
        return Promise.all([
          new Promise((resolve, reject) => {
            this.$refs.form.validate((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          }),
          new Promise((resolve, reject) => {
            this.$refs.inventoryTable.validateForm((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          })
        ]);
      },
      async save(type) {
        let is = false;
        try {
          await this.getValidate();
          // 表单验证通过，执行保存操作
          this.loading = true;
          let isTemporary = [];

          if (!this.isUpdate) {
            delete this.form.id;
          }
          if (!this.form.contractId) {
            this.form.totalAmount = this.allcountAmount;
          }
          const rawDetailList =
            (this.$refs.rawDetailListRef &&
              this.$refs.rawDetailListRef.getTableValue()) ||
            [];
          const outputDetailList =
            (this.$refs.outputDetailListRef &&
              this.$refs.outputDetailListRef.getTableValue()) ||
            [];
          const tabList =
            (this.$refs.inventoryTable &&
              this.$refs.inventoryTable.getTableValue()) ||
            [];
          tabList.forEach((v, i) => {
            if (!v.productCode) {
              isTemporary.push(v.productName);
            }
            // tabList.forEach((v2, j) => {
            //   if (
            //     v.productCode == v2.productCode &&
            //     v.taskId == v2.taskId &&
            //     v.batchNo == v2.batchNo &&
            //     i != j
            //   ) {
            //     is = true;
            //   }
            // });
          });

          if (isTemporary.length > 0) {
            this.$message.error(
              isTemporary.toString() +
                '是临时产品，无法创建订单，请先去主数据维护！'
            );

            return;
          }

          // if (is) {
          //   this.$message.error('同产品，工序、批次号不能完全一致！');
          //   return;
          // }
          let productList = [
            ...tabList,
            ...rawDetailList.map((item) => {
              item.singlePrice = item.singlePrice || 0;
              item.discountSinglePrice = item.discountSinglePrice || 0;
              item.totalPrice = item.totalPrice || 0;
              item.discountTotalPrice = item.discountTotalPrice || 0;

              return item;
            }),
            ...outputDetailList.map((item) => {
              item.singlePrice = item.singlePrice || 0;
              item.discountSinglePrice = item.discountSinglePrice || 0;
              item.discountTotalPrice = item.discountTotalPrice || 0;
              item.totalPrice = item.totalPrice || 0;

              return item;
            })
          ];

          let commitData = Object.assign({}, this.form, {
            productList,
            // purchaseTypeName: this.getDictValue(
            //   '采购订单类型',
            //   this.form.purchaseType
            // ),
            sourceTypeName: this.requirementSourceType.find(
              (val) => val.value == this.form.sourceType
            )?.label
          });
          if (this.isUpdate) {
            UpdateInformation(commitData)
              .then((res) => {
                this.loading = false;
                this.$message.success('修改成功');
                updateRelationStatus([this.form.partbId]);
                if (this.form.contractId) {
                  updateContractStatus([this.form.contractId]);
                }
                if (type === 'sub') {
                  this.sub(res);
                  return;
                }
                this.cancel();
                this.$emit('done');
              })
              .catch((e) => {
                //this.loading = false;
              });
          } else {
            addInformation(commitData)
              .then((res) => {
                this.loading = false;
                this.$message.success('新增成功');
                updateRelationStatus([this.form.partbId]);
                if (type === 'sub') {
                  this.sub(res);
                  return;
                }
                this.cancel();
                this.$emit('done');
              })
              .catch((e) => {
                //this.loading = false;
              });
          }
        } catch (error) {
          console.log(error);
          // 表单验证未通过，不执行保存操作
        }
      },
      async sub(res) {
        const data = await getpurchaseorderDetail(this.businessId || res);
        this.processSubmitDialogFlag = true;
        this.$nextTick(() => {
          let params = {
            businessId: data.id,
            businessKey: 'purchase_order_approve',
            formCreateUserId: data.createUserId,
            variables: {
              businessCode: data.orderNo,
              businessName: data.partaName,
              businessType: data.sourceTypeName
            }
            // callBackMethodType : '1',
            // callBackMethod : 'proTargetPlanApproveApiImpl.updatePlanApprovalStatus',
            // pcHandle : '/bpm/handleTask/components/project-manage/plan-manage/submit.vue',
            // pcView : '/bpm/handleTask/components/project-manage/plan-manage/detailDialog.vue',
            // miniHandle : '',
            // miniView : '',
          };

          this.$refs.processSubmitDialogRef.init(params);
        });
        // submit({
        //   businessId: this.businessId || res
        // }).then((res) => {
        //   this.cancel();
        //   this.$emit('done');
        // });
      },
      reload() {
        this.cancel();
        this.$emit('done');
      },
      cancel() {
        this.$nextTick(() => {
          this.isFlag = false;
          // 关闭后，销毁所有的表单数据
          this.$refs['otherForm'] && this.$refs['otherForm'].resetFields();
          this.$refs['formRef'] && this.$refs['formRef'].resetFields();
          this.$store.commit('order/clearUserData');
          this.form = copyObj(this.formDef);
          this.visible = false;
        });
      },
      //查找合同分类对应name
      findNameById(tree, targetId) {
        for (let i = 0; i < tree.length; i++) {
          const node = tree[i];
          if (node.id === targetId) {
            return node.name;
          }
          if (node.children && node.children.length > 0) {
            const name = this.findNameById(node.children, targetId);
            if (name) {
              return name;
            }
          }
        }
        return null;
      }
    }
  };
</script>
<style scoped lang="scss">
  .TotalAmount {
    font-size: 16px;
    padding-right: 30px;
  }
</style>
